/*
 * Copyright (c) 2015-2017, Sumio Morioka
 * All rights reserved.
 *
 * This source code was originally written by Dr.Sumio Morioka for use in the 2015-2017 issues of 
 * "the Interface magazine", published by CQ publishing Co.Ltd in Japan (http://www.cqpub.co.jp).
 * The author has no responsibility on any results caused by using this code.
 *
 * - Author: Dr.Sumio Morioka (http://www002.upp.so-net.ne.jp/morioka, FB:Sumio Morioka)
 *
 *
 * IMPORTANT NOTICE:
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *   * Neither the name of the copyright holder nor the
 *     names of its contributors may be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef _WEBSOCKET_FUNC_H
#define _WEBSOCKET_FUNC_H

#include "websocket_flags.h"

//////////////////////////////////////////////////////////////////////////// >>
// ADD YOUR ORIGINAL CODE HERE
// BODY of global variables

#define	CAR_STOP	0
#define	CAR_FWD		1
#define	CAR_BAK		2
#define	CAR_LEFT	3
#define	CAR_RIGHT	4

char	current_movement_G	= CAR_STOP;
//////////////////////////////////////////////////////////////////////////// <<

//static int wsocket_callback_dumb_increment(struct libwebsocket_context *cntxt,
//                                   struct libwebsocket *wsi,
//                                   enum libwebsocket_callback_reasons reason,
//                                   void *user,
//                                   void *inp,
//                                   size_t len)	// (main callback func)
static int  wsocket_callback_dumb_increment(
									struct lws *wsi, 
									enum lws_callback_reasons reason, 
									void *user, 
									void *inp, 
									size_t len) 
{
//////////////////////////////////////////////////////////////////////////// >>
// ADD YOUR ORIGINAL CODE HERE
	switch (reason) {
	case LWS_CALLBACK_ESTABLISHED:
		pthread_mutex_lock(&tracker_mutex_G);	// lock
		if (tracking_status_G	!= TRACKING_NONE) {
			tracker_G->clear();
		}
		tracking_status_G	= TRACKING_NONE;
		pthread_mutex_unlock(&tracker_mutex_G);	// unlock

		send_serial16(0, 0x0000);		// stop
		current_movement_G	= CAR_STOP;

		fprintf(stderr, "websocket: connection established\n");
		break;

	case LWS_CALLBACK_RECEIVE:
		if (*((char *)inp) != '!') {	// NOT KEEP ALIVE MARK
			int	x, y;
			int	target_dir;

			int	posx, posy;
			int	win_x, win_y;

			switch (*((char *)inp)) {
			case 'c':
				send_serial16(0, 0x0000);		// stop
				current_movement_G	= CAR_STOP;
				break;

			case 'u':
				send_serial16(0, 0x0000);		// stop
				send_serial16(1, 0);			// limit

				target_dir	= receive_serial16(0x0D);		// get current direction
				send_serial16(2, (unsigned int)target_dir);	// set same target

				send_serial16(0,
					   (1 & 0x0001)				// start
					+ ((0 << 1) & 0x0006)		// mode
					+ ((255 << 8) & 0xFF00)		// pwm
				);
				current_movement_G	= CAR_FWD;
				break;

			case 'd':
				send_serial16(0, 0x0000);		// stop
				send_serial16(1, 0);			// limit

				target_dir	= receive_serial16(0x0D);		// get current direction
				send_serial16(2, (unsigned int)target_dir);	// set same target

				send_serial16(0,
					   (1 & 0x0001)				// start
					+ ((1 << 1) & 0x0006)		// mode
					+ ((255 << 8) & 0xFF00)		// pwm
				);
				current_movement_G	= CAR_BAK;
				break;

			case 'l':
				send_serial16(0, 0x0000);		// stop
				send_serial16(1, 0);			// limit

				target_dir	= receive_serial16(0x0D);	// get current direction
				target_dir	-= 500;					// 5 degree
				while (target_dir < 0) {
					target_dir	+= 36000;
				}
				send_serial16(2, (unsigned int)target_dir);	// set new target

				send_serial16(0,
					   (1 & 0x0001)				// start
					+ ((3 << 1) & 0x0006)		// mode
					+ ((255 << 8) & 0xFF00)		// pwm
				);
				current_movement_G	= CAR_LEFT;
				break;

			case 'r':
				send_serial16(0, 0x0000);		// stop
				send_serial16(1, 0);			// limit

				target_dir	= receive_serial16(0x0D);	// get current direction
				target_dir	+= 500;					// 5 degree
				while (target_dir >= 36000) {
					target_dir	-= 36000;
				}
				send_serial16(2, (unsigned int)target_dir);	// set new target

				send_serial16(0,
					   (1 & 0x0001)				// start
					+ ((2 << 1) & 0x0006)		// mode
					+ ((255 << 8) & 0xFF00)		// pwm
				);
				current_movement_G	= CAR_RIGHT;
				break;

			case 'i':	// click image
				// calc target position
				sscanf((char *)inp, "i%d,%d", &x, &y);

				posx	= (DEFAULT_WIDTH  * x) / 100;
				posy	= (DEFAULT_HEIGHT * y) / 100;

				win_x	= posx - TRACKING_WINSIZE / 2;
				win_y	= posy - TRACKING_WINSIZE / 2;

				// overflow/underflow check
				if (win_x < 0)
					win_x	= 0;
				else if (win_x + TRACKING_WINSIZE >= DEFAULT_WIDTH)
					win_x	= DEFAULT_WIDTH - 1 - TRACKING_WINSIZE;

				if (win_y < 0)
					win_y	= 0;
				else if (win_y + TRACKING_WINSIZE >= DEFAULT_HEIGHT)
					win_y	= DEFAULT_HEIGHT - 1 - TRACKING_WINSIZE;

				// change status
				pthread_mutex_lock(&tracker_mutex_G);	// lock
				if (tracking_status_G	== TRACKING_NONE) {
					// set target location
					tracking_roi_G.x		= win_x;
					tracking_roi_G.y		= win_y;
					tracking_roi_G.width	= TRACKING_WINSIZE;
					tracking_roi_G.height	= TRACKING_WINSIZE;

					tracking_status_G		= TRACKING_PREP;
					tracking_moved_G		= 0;

					fprintf(stderr, "track position <%d, %d>\n", win_x, win_y);
				}
				else {
					if (tracking_status_G	!= TRACKING_NONE) {
						tracker_G->clear();
					}
					tracking_status_G	= TRACKING_NONE;

					// force stopping movement
					send_serial16(0, 0x0000);		// stop
					current_movement_G	= CAR_STOP;

					fprintf(stderr, "stop tracking\n");
				}
				pthread_mutex_unlock(&tracker_mutex_G);	// unlock
				break;

			default:
				break;
			}
		}

		// send response TO AVOID TIMEOUT
		{
			unsigned char	buf	= '!';
//			libwebsocket_write(wsi, &buf, 1, LWS_WRITE_TEXT);
			lws_write(wsi, &buf, 1, LWS_WRITE_TEXT);
		}
		break;

	case LWS_CALLBACK_CLOSED:
		pthread_mutex_lock(&tracker_mutex_G);	// lock
		if (tracking_status_G	!= TRACKING_NONE) {
			tracker_G->clear();
		}
		tracking_status_G	= TRACKING_NONE;
		pthread_mutex_unlock(&tracker_mutex_G);	// unlock

		send_serial16(0, 0x0000);	// stop
		current_movement_G	= CAR_STOP;

		fprintf(stderr, "websocket: connection closed\n");
		break;

	default:
		break;
    }

	return 0;
//////////////////////////////////////////////////////////////////////////// <<
}

#endif // _WEBSOCKET_FUNC_H

// end of file
